<?
/************************************************************************
 * Web Tools (WT) - a collection of web hosting tools                   *
 * Module CONFIG - 0.2 - wt plugin config tool                                *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful, but  *
 * WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 * General Public License for more details.                             *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 *    Free Software Foundation, Inc.                                    *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         *
 ************************************************************************/

 // get all the present plugins in the directory
$wt_plugin_list = array();
$wt_plugin_path = $wt_root_path . $wt_plugins_dir;
$wt_cpt         = 0;
$wt_handle = @opendir($wt_plugin_path); 
while( ($wt_file = @readdir($wt_handle)) !== false ) {
	if( $wt_file == "." || $wt_file == ".." ) continue;
	if( !@file_exists($wt_plugin_path.$wt_file) ) continue;
	if (substr($wt_file, strlen($wt_file)-7) == ".wt.php") {
	    $wt_plugin_name = substr($wt_file, 0, strlen($wt_file)-7);
	    if ($wt_plugin_name != "config" && $wt_plugin_name != "about") {
	        $wt_plugin_list[$wt_cpt] = $wt_plugin_name ; 
	        // echo $wt_file . " : " . $wt_plugin_name . "<br />";
	        $wt_cpt++;
        }
	}
}
@closedir($wt_handle); 
if (count($wt_plugin_list) > 0) sort($wt_plugin_list); 
?>

<center>
<h2>plugin configuration</h2>


<?// reads the config file, and carries on only if file is accessible
if (wt_read_cfg_file()) {

    if ($wt_action=="cfgadd") { // --------------------------------- add cfg item --------
        $wt_plugname        = trim(wt_init_var('plugname'));
        $wt_plugtitle       = trim(wt_init_var('plugtitle'));
        $wt_pluglabel       = trim(wt_init_var('pluglabel'));
        $wt_plugsection     = trim(wt_init_var('plugsection'));
        $wt_filename        = $wt_plugname . ".wt.php";
        $wt_cfg_line        = $wt_plugname . "|" . $wt_pluglabel . "|" . $wt_plugtitle . "|" . $wt_plugsection;
        
        if (empty($wt_plugname)) {
            wt_error("no plugin selected !");
        } else if (wt_is_valid_path($wt_filename)) {
            wt_error("invalid plugin");
        } else {
            wt_msg("plugin '$wt_pluglabel' added successfuly in the configuration file");
            $wt_cfg_item[count($wt_cfg_item)] = $wt_cfg_line;
            wt_update_cfg_file();
        }
        // we added the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgdel") { // --------------------------------- del cfg item --------
        $wt_item_id     = wt_init_var('id');
        wt_msg("plugin deactivated successfuly");
        $wt_cfg_item[$wt_item_id] = '';
        wt_update_cfg_file();
        // we deleted the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgup") { // --------------------------------- move up item --------
        $wt_item_id     = wt_init_var('id');
        //wt_msg("plugin moved up successfuly");
        $wt_tmp = $wt_cfg_item[$wt_item_id];
        $wt_cfg_item[$wt_item_id] = $wt_cfg_item[$wt_item_id-1];
        $wt_cfg_item[$wt_item_id-1] = $wt_tmp;
        wt_update_cfg_file();

        // we moved the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgdown") { // --------------------------------- move down item --------
        $wt_item_id     = wt_init_var('id');
        //wt_msg("plugin moved down successfuly");
        $wt_tmp = $wt_cfg_item[$wt_item_id];
        $wt_cfg_item[$wt_item_id] = $wt_cfg_item[$wt_item_id+1];
        $wt_cfg_item[$wt_item_id+1] = $wt_tmp;
        wt_update_cfg_file();
        // we moved the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgedit") { // --------------------------------- edit user --------
        $wt_item_id         = wt_init_var('id');
        $wt_plugname        = trim(wt_init_var('plugname'));
        $wt_plugtitle       = trim(wt_init_var('plugtitle'));
        $wt_pluglabel       = trim(wt_init_var('pluglabel'));
        $wt_plugsection     = trim(wt_init_var('plugsection'));
        $wt_filename        = $wt_plugname . ".wt.php";
        $wt_cfg_line        = $wt_plugname . "|" . $wt_pluglabel . "|" . $wt_plugtitle . "|" . $wt_plugsection;
        if (empty($wt_plugname)) {
            wt_error("no plugin selected !");
        } else if (wt_is_valid_path($wt_filename)) {
            wt_error("invalid plugin");
        } else {
            wt_msg("plugin '$wt_pluglabel' edited successfuly in the configuration file");
            $wt_cfg_item[$wt_item_id] = $wt_cfg_line;
            wt_update_cfg_file();
        }
        // we updated the user; we get the list again
        $wt_action="";
    }


	if (!isset($wt_action) || $wt_action == "") {  // --------------------------------- MAIN --------

?>
  <script language="JavaScript">
        function wt_del_plugin(pluginid) {
            cf = confirm("Are you sure you want to deactivate this plugin?");
            if (cf) {
                document.location = "<? echo $PHP_SELF; ?>?section=<? echo $wt_section; ?>&action=cfgdel&id="+pluginid+"";
            }
        }

  </script>
  <table class="list">
    <tr>
      <td class="top">plugin</td>
      <td class="top">label</td>
      <td class="top">title</td>
      <td class="top">section</td>
      <td class="top">actions</td>
    </tr>
<?
            $wt_col = 1; $wt_cpt = 0;

            for ($wt_plugin_id = 0; $wt_plugin_id < count($wt_cfg_item); $wt_plugin_id++) {
                $wt_plugin = explode("|", $wt_cfg_item[$wt_plugin_id]);
                $wt_cpt++;
                echo "<form name=\"form_edit" . $wt_cpt . "\" action=\"" . $PHP_SELF . "\"><tr>";
                
                // echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"plugname\" class=\"table\" value=\"" . $wt_plugin[0] . "\" size=\"10\"></td>";
                echo "<td class=\"line" . $wt_col . "\">";
                echo "<select name=\"plugname\">"; 
                for ($wt_cpt = 0; $wt_cpt < count($wt_plugin_list); $wt_cpt++) {
                    echo "<option value=\"" . $wt_plugin_list[$wt_cpt] . "\"";
                    if ($wt_plugin_list[$wt_cpt] == $wt_plugin[0]) echo " selected ";
                    echo ">" . $wt_plugin_list[$wt_cpt] . "</option>";
                }
                echo "</select>";
                echo "</td>";
                
                echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"pluglabel\" class=\"table\" value=\"" . $wt_plugin[1] . "\" size=\"10\"></td>";
                echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"plugtitle\" class=\"table\" value=\"" . $wt_plugin[2] . "\" size=\"20\"></td>";
                echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"plugsection\" class=\"table\" value=\"" . $wt_plugin[3] . "\" size=\"7\"></td>";
                echo "<input type=\"hidden\" name=\"section\" value=\"$wt_section\">";
                echo "<input type=\"hidden\" name=\"action\" value=\"cfgedit\">";
                echo "<input type=\"hidden\" name=\"id\" value=\"" . $wt_plugin_id . "\">";
                echo "<td class=\"line" . $wt_col . "\"><input type=\"submit\" name=\"submit\" value=\"update\" class=\"submit\">";
                echo "&nbsp;<a class=\"submit\" href=\"javascript:wt_del_plugin('$wt_plugin_id')\">remove</a>";
                if ($wt_plugin_id != 0) echo "&nbsp;<a class=\"submit\" href=\"$PHP_SELF?section=$wt_section&action=cfgup&id=$wt_plugin_id\">up</a>";
                if ($wt_plugin_id != count($wt_cfg_item) - 1) echo "&nbsp;<a class=\"submit\" href=\"$PHP_SELF?section=$wt_section&action=cfgdown&id=$wt_plugin_id\">down</a>";
                echo "</td>";
                echo "</form></tr>";

                $wt_col++; if ($wt_col==3) $wt_col=1;         
            }  
            // add a line to add an user
            echo "<form name=\"form_add\" action=\"" . $PHP_SELF . "\"><tr>";
            //echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"plugname\" class=\"table\" size=\"10\"></td>";
            echo "<td class=\"line" . $wt_col . "\">";
            echo "<select name=\"plugname\">"; 
            echo "<option value=\"\"></option>";
            for ($wt_cpt = 0; $wt_cpt < count($wt_plugin_list); $wt_cpt++) {
                echo "<option value=\"" . $wt_plugin_list[$wt_cpt] . "\">" . $wt_plugin_list[$wt_cpt] . "</option>";
            }
            echo "</select>";
            echo "</td>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"pluglabel\" class=\"table\" size=\"10\"></td>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"plugtitle\" class=\"table\" size=\"20\"></td>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"plugsection\" class=\"table\" size=\"7\"></td>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"hidden\" name=\"section\" value=\"$wt_section\">";
            echo "<input type=\"hidden\" name=\"action\" value=\"cfgadd\">";
            echo "<input type=\"submit\" name=\"submit\" value=\"add\" class=\"submit\"></td>";
            echo "</tr></form>";
        }
?>
  </table>
<?
    echo "<br /><a class=\"small\" href=\"$PHP_SELF?section=$wt_section\">click here to refresh the navigation menu</a>";   
?>
</center>

<?
}
?>
